<?php
/**
 * Enter description here ...
 *
 * @package Logic
 *
 * @author  alessandrobartels
 *
 */
class IRRF {


    /**
     * Enter description here ...
     *
     * @param integer                   $incidencia       Incidencia.
     * @param integer                   $evento           Evento.
     * @param integer                   $evento_base      Evento Base.
     * @param TkDateTime                $mes_competencia  Mes Competencia.
     * @param FpaitecalcfolhaEntity     $item_de_calculo  Item de Calculo.
     * @param FpaassoceventoEntity      $assoc_evento     Assoc_evento.
     * @param FpaeventomEntity          $eventom          Evento.
     * @param FpaValorreferenciamEntity $valor_referencia Valor Referencia.
     * @param GpevinculomEntity         $vinculo          Vinculo.
     * @param boolean                   $acumulaRecMinimo Acumula Recolhimento inferior a 10 reais
     * @param boolean                   $plr Define se é calculo de PLR ou NÃO
     *
     * @return void
     *
     * @author alessandrobartels -
     *         alessandrobartels - 27/06/2011 - Implementacao do NRORG no metodo retornaEvento
     */
    public static function calcula(
        $incidencia, $evento, $evento_base, TkDateTime $mes_competencia, FpaitecalcfolhaEntity $item_de_calculo,
        FpaassoceventoEntity $assoc_evento, FpaeventomEntity $eventom, FpaValorreferenciamEntity $valor_referencia,
        GpevinculomEntity $vinculo, $acumulaRecMinimo,$plr=false
    ) {

        /* 1-porque a tabela valor de referencia so tem uma linha */
//        $vr_referencia = $valor_referencia->retornaValorReferencia(1);

        $nr_dependentes = $vinculo->historico->getNrdependir();

        $vrDeducaoDependente = $valor_referencia->getValorReferencia(FpaValorreferenciamEntity::VR_DEDUCAO_DEP_IR);
//        $deducao_dependente = $nr_dependentes * $vr_referencia->getVrdedudependir();
        $deducao_dependente = $nr_dependentes * $vrDeducaoDependente;

        $nrevento =  $assoc_evento->retornaEvento(
            FpatipoassoceveEntity::ASSOC_DEDUCAO_DEPENDENTE, $vinculo->getNrorg()
        );
        $evento_deducao_dependente = $eventom->retornaEvento($nrevento);
        /*$item_de_calculo->geraEvento(
            $evento_deducao_dependente, $mes_competencia, $deducao_dependente, $nr_dependentes, 1
        );
        */
        $item_de_calculo->geraEvento(
            $evento_deducao_dependente, null, $deducao_dependente, $nr_dependentes, 1
        );

        $base = $item_de_calculo->calculaIncidencias(
            $incidencia, $mes_competencia, $eventom
        );

        // Se a base for menor que 0, a mesma passa a ser 0.
        if ($base < 0) {
            $base = 0;
        }

        $nrevento =  $assoc_evento->retornaEvento($evento_base, $vinculo->getNrorg());
        $evento_base_irrf = $eventom->retornaEvento($nrevento);
        // $item_de_calculo->geraEvento($evento_base_irrf, $mes_competencia, $base, 0, 1);.
        $item_de_calculo->geraEvento($evento_base_irrf, null, $base, 0, 1);
        // $indice = $item_de_calculo->procuraEvento($evento_base_irrf, $mes_competencia);.
        $indice = $item_de_calculo->procuraEvento($evento_base_irrf, null);
        /* Busca base novamente para aproveitar todo o tratamento generico do evento (centavos, valor negativo, etc.) */
        if ($indice !== -1) {
            $base = $item_de_calculo->retornaValor($indice);
        } else {
            $base = 0;
        }

        $referencia = 0;
        /*BORBA 23/03/2015 Somente na chamada do plr passará true*/
        if($plr==true){
            $irrf = FpafaixatabelaEntity::retornaValorProcessado(
                $base, FpatabelafolhaEntity::TAB_IRRF_PLR, $mes_competencia, $referencia
            );
        }else {
            $irrf = FpafaixatabelaEntity::retornaValorProcessado(
                $base, FpatabelafolhaEntity::TAB_IRRF, $mes_competencia, $referencia
            );
        }
        /* alessandrobartels - 26/08/2011 Calculo do IR ja descontado */
        $nrevento =  $assoc_evento->retornaEvento(
            FpatipoassoceveEntity::ASSOC_IRRF_JA_DESC_CALC, $vinculo->getNrorg()
        );
        $evento_irrf_descontado = $eventom->retornaEvento($nrevento);
        $posicao = $item_de_calculo->procuraEvento($evento_irrf_descontado);
        if ($posicao !== -1) {
            $irDescontado = $item_de_calculo->retornaValor($posicao);
            $irrf -= $irDescontado;
        }

        // Verificar se existe o evento de Imposto de Renda no Mes Anterior (1332).
        $nrevento =  $assoc_evento->retornaEvento(FpaTipoassoceveEntity::ASSOC_IRRF_CALC_MES_ANTERIOR, $vinculo->getNrorg());
        $evento_mesAnterior = $eventom->retornaEvento($nrevento);
        $posicao = $item_de_calculo->procuraEvento($evento_mesAnterior, $mes_competencia);
        if ($posicao !== -1){
            $irrf_MesAnterior = $item_de_calculo->retornaValor($posicao);
            //$referencia = $item_de_calculo->retornaReferencia($posicao);
            $irrf += $irrf_MesAnterior;
            
        }


        // Compara o IR calculado com o valor de recolhimento minimo. So gera item calculo se for maior que o minimo.
        $vrRecolhimentoMinimo = (float)$valor_referencia->getValorReferencia(FpaValorreferenciamEntity::VR_RECOLHIMENTO_MIN_IR);
        if ($irrf > $vrRecolhimentoMinimo) {
            
            $nrevento =  $assoc_evento->retornaEvento($evento, $vinculo->getNrorg());
            $evento_irrf = $eventom->retornaEvento($nrevento);
            // $item_de_calculo->geraEvento($evento_irrf, $mes_competencia, $irrf, 0, 1);.
            $item_de_calculo->geraEvento($evento_irrf, null, $irrf, $referencia, 1);
        } else {

            // IR com recolhimento minimo.
            // Verificar se efetua recolhimento - flag no parametro de folha
            if ($acumulaRecMinimo === FpaParamfolhahEntity::IDIRRFRECOLHMIN_SIM){
                $nrevento =  $assoc_evento->retornaEvento(FpaTipoassoceveEntity::ASSOC_IRRF_CALC_ACUMULADO, $vinculo->getNrorg());
                $evento_irrf_acumulado = $eventom->retornaEvento($nrevento);
                // Gerar evento acumulado
                $item_de_calculo->geraEvento($evento_irrf_acumulado, null, $irrf, null, 2);
            }


        }


    }


}