/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_OPERALMOX                                                */
/* Tabela : OPERALMOX                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 28/10/2004 - Ronaldo Amaral Costa                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_OPERALMOX' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_OPERALMOX
GO

CREATE TRIGGER DTULTATU_OPERALMOX
ON OPERALMOX
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'OPERALMOX', CDFILIAL, 'CDFILIAL='+ CDFILIAL+ ';'+
                                      'CDOPERADOR='+ CDOPERADOR+ ';' +'CDALMOXARIFE='+ CDALMOXARIFE+ ';',
                                      GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE OPERALMOX
      SET DTULTATUOPAX = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(OPERALMOX.CDOPERADOR,0)   = ISNULL(INSERTED.CDOPERADOR,0)) AND
            (ISNULL(OPERALMOX.CDFILIAL,0)     = ISNULL(INSERTED.CDFILIAL,0)) AND
            (ISNULL(OPERALMOX.CDALMOXARIFE,0) = ISNULL(INSERTED.CDALMOXARIFE,0));
   END;
END;
GO


